## mingw-w64-verdict-1.4.4-1.src.tar.zst

=== CMakeLists.txt ===
# Copyright 2003,2006,2019 National Technology & Engineering Solutions of Sandia, LLC (NTESS).
# Under the terms of Contract DE-NA0003525 with NTESS,
# the U.S. Government retains certain rights in this software.

cmake_minimum_required(VERSION 3.16)

project(verdict LANGUAGES CXX VERSION 1.4.4)

# Enable CUDA if requested
option(VERDICT_ENABLE_CUDA "Build Verdict with CUDA support." OFF)

if (VERDICT_ENABLE_CUDA)
  enable_language(CUDA)
endif ()

# Enable HIP if requested
option(VERDICT_ENABLE_HIP "Build Verdict with HIP support." OFF)

if (VERDICT_ENABLE_HIP)
  if(${CMAKE_VERSION} VERSION_LESS 3.21.0)
    message(FATAL_ERROR "HIP support requires CMake 3.21 or above.")
  endif()

  enable_language(HIP)
endif()

# Includes
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

if (POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif ()

set(verdict_VERSION_FLAT "${verdict_VERSION_MAJOR}${verdict_VERSION_MINOR}${verdict_VERSION_PATCH}")

option(BUILD_SHARED_LIBS "Build Verdict as shared libraries." OFF)
option(VERDICT_BUILD_DOC "Build the 2007 Verdict User Manual" OFF)
option(VERDICT_MANGLE "Mangle verdict names for inclusion in a larger library?" OFF)
if (VERDICT_MANGLE)
  set(VERDICT_MANGLE_PREFIX "verdict" CACHE STRING "The namespace enclosing verdict function names and classes.")
  mark_as_advanced(VERDICT_MANGLE_PREFIX)
endif ()
mark_as_advanced(VERDICT_MANGLE)

option(VERDICT_ENABLE_TESTING "Should tests of the VERDICT library be built?" ON)

set(verdict_HEADERS
  verdict.h
  VerdictVector.hpp
  V_GaussIntegration.hpp
  verdict_defines.hpp)

set(verdict_SOURCES
  V_EdgeMetric.cpp
  V_GaussIntegration.cpp
  V_HexMetric.cpp
  V_KnifeMetric.cpp
  V_PyramidMetric.cpp
  V_QuadMetric.cpp
  V_TetMetric.cpp
  V_TriMetric.cpp
  V_WedgeMetric.cpp
  VerdictVector.cpp)

if (VERDICT_ENABLE_CUDA)
  set_source_files_properties(${verdict_SOURCES} PROPERTIES LANGUAGE CUDA)
elseif (VERDICT_ENABLE_HIP)
  set_source_files_properties(${verdict_SOURCES} PROPERTIES LANGUAGE HIP)
endif ()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/verdict_config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/verdict_config.h
  @ONLY)

add_library(verdict ${verdict_SOURCES} ${verdict_HEADERS} ${CMAKE_CURRENT_BINARY_DIR}/verdict_config.h)
target_compile_features(verdict PRIVATE cxx_std_11)
target_include_directories(verdict PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}> $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
if(UNIX)
  target_link_libraries(verdict PRIVATE m)
endif()


# Setting the VERSION and SOVERSION of a library will include
# version information either in the library, or in the library
# name (depending on the platform). You may choose to exclude
# this information.
if (NOT VERDICT_NO_LIBRARY_VERSION)
  set_target_properties(verdict PROPERTIES
    VERSION "${verdict_VERSION}"
    SOVERSION "${verdict_VERSION_MAJOR}.${verdict_VERSION_MINOR}")
endif ()
if (NOT VERDICT_EXPORT_GROUP)
  set(VERDICT_EXPORT_GROUP VerdictExport)
endif ()

if (VERDICT_ENABLE_TESTING)
  enable_testing()
  if (NOT TARGET GTest::GTest)
    find_package(GTest REQUIRED)
  endif ()

  function(add_verdict_unittests DIR)
    add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/${DIR} ${CMAKE_CURRENT_BINARY_DIR}/${DIR})

    foreach (TEST ${ARGN})
      add_test(NAME UT-${TEST}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${DIR}
        COMMAND ${TEST})
    endforeach (TEST ${ARGN})
  endfunction()

  add_verdict_unittests(unittests unittests_verdict)
endif ()

if (VERDICT_BUILD_DOC)
  add_subdirectory(docs/VerdictUserManual2007)
endif ()

#########################
# Installation commands #
#########################
if (NOT verdict_INSTALL_DOC_DIR)
  set(verdict_INSTALL_DOC_DIR ${CMAKE_INSTALL_DOCDIR})
endif ()
if (NOT verdict_INSTALL_INCLUDE_DIR)
  set(verdict_INSTALL_INCLUDE_DIR ${CMAKE_INSTALL_INCLUDEDIR})
endif ()
if (NOT verdict_INSTALL_INCLUDE_SUBDIR)
  set(verdict_INSTALL_INCLUDE_SUBDIR verdict)
endif ()
if (NOT verdict_INSTALL_BIN_DIR)
  set(verdict_INSTALL_BIN_DIR ${CMAKE_INSTALL_BINDIR})
endif ()
if (NOT verdict_INSTALL_LIB_DIR)
  set(verdict_INSTALL_LIB_DIR ${CMAKE_INSTALL_LIBDIR})
endif ()
if (NOT verdict_INSTALL_CMAKE_DIR)
  set(verdict_INSTALL_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/verdict)
endif ()

# Install documentation
install(FILES
  README.md
  DESTINATION ${verdict_INSTALL_DOC_DIR}/verdict/${verdict_VERSION}/ COMPONENT VerdictDevelopment)

# Install required header files
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/verdict_config.h
  verdict.h
  DESTINATION ${verdict_INSTALL_INCLUDE_DIR} COMPONENT VerdictDevelopment)
target_include_directories(verdict PUBLIC $<INSTALL_INTERFACE:${verdict_INSTALL_INCLUDE_DIR}>)

# Install library
install(TARGETS verdict EXPORT ${VERDICT_EXPORT_GROUP}
  RUNTIME DESTINATION ${verdict_INSTALL_BIN_DIR} COMPONENT Runtime # .exe, .dll
  LIBRARY DESTINATION ${verdict_INSTALL_LIB_DIR} COMPONENT Runtime # .so, .dll
  ARCHIVE DESTINATION ${verdict_INSTALL_LIB_DIR} COMPONENT VerdictDevelopment #[[.a, .lib]])

# Export Targets file
export(EXPORT ${VERDICT_EXPORT_GROUP}
  FILE "${CMAKE_CURRENT_BINARY_DIR}/VerdictTargets.cmake"
  NAMESPACE Verdict::)

# Install Targets file
install(EXPORT ${VERDICT_EXPORT_GROUP}
  FILE "VerdictTargets.cmake"
  NAMESPACE Verdict::
  DESTINATION ${verdict_INSTALL_CMAKE_DIR} COMPONENT VerdictDevelopment)

# Create Config file
configure_package_config_file(${CMAKE_CURRENT_SOURCE_DIR}/VerdictConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/VerdictConfig.cmake"
  INSTALL_DESTINATION ${verdict_INSTALL_CMAKE_DIR})

# Generate the version file for the Config file
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/VerdictConfigVersion.cmake"
  VERSION "${verdict_VERSION}"
  COMPATIBILITY AnyNewerVersion)

# Install Config and ConfigVersion files
install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/VerdictConfig.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/VerdictConfigVersion.cmake"
  DESTINATION ${verdict_INSTALL_CMAKE_DIR} COMPONENT VerdictDevelopment)

=== unittests/CMakeLists.txt ===

SET(TEST_SRCS
    unittest_main.cpp
    verdict.test.cpp
   )

ADD_EXECUTABLE(unittests_verdict ${TEST_SRCS})
TARGET_LINK_LIBRARIES(unittests_verdict verdict GTest::GTest)

=== docs/VerdictUserManual2007/CMakeLists.txt ===
PROJECT(PAPER NONE)

SET(CMAKE_C_FLAGS "")
SET(CMAKE_C_FLAGS_RELEASE "")
SET(CMAKE_C_FLAGS_MINSIZEREL "")
SET(CMAKE_C_FLAGS_DEBUG "")
SET(CMAKE_C_FLAGS_RELWITHDEBINFO "")

# Document
SET(DOCUMENT Verdict-Manual-2007)
SET(LITERATURE Verdict-Manual-2007)
SET(SECTIONS
  VerdictMathMacros.tex
  00-Introduction.tex
  10-Instructions.tex
  API.tex
  Hex.tex
  HexDiagonal.tex
  HexDimension.tex
  HexDistortion.tex
  HexEdgeRatio.tex
  HexJacobian.tex
  HexMaximumEdgeRatio.tex
  HexMaxAspectFrobenius.tex
  HexMedAspectFrobenius.tex
  HexRelativeSizeSquared.tex
  HexScaledJacobian.tex
  HexShape.tex
  HexShapeAndSize.tex
  HexShear.tex
  HexShearAndSize.tex
  HexSkew.tex
  HexStretch.tex
  HexTaper.tex
  HexVolume.tex
  HexOddy.tex
  Quad.tex
  QuadArea.tex
  QuadAspectRatio.tex
  QuadEdgeRatio.tex
  QuadRadiusRatio.tex
  QuadMedAspectFrobenius.tex
  QuadMaxAspectFrobenius.tex
  QuadCondition.tex
  QuadDistortion.tex
  QuadEdgeRatio.tex
  QuadJacobian.tex
  QuadMaxAspectFrobenius.tex
  QuadMaximumAngle.tex
  QuadMaximumEdgeRatio.tex
  QuadMedAspectFrobenius.tex
  QuadMinimumAngle.tex
  QuadOddy.tex
  QuadRadiusRatio.tex
  QuadRelativeSizeSquared.tex
  QuadScaledJacobian.tex
  QuadShapeAndSize.tex
  QuadShape.tex
  QuadShearAndSize.tex
  QuadShear.tex
  QuadSkew.tex
  QuadStretch.tex
  QuadTaper.tex
  QuadWarpage.tex
  Tet.tex
  TetEdgeRatio.tex
  TetAspectBeta.tex
  TetAspectDelta.tex
  TetAspectFrobenius.tex
  TetAspectGamma.tex
  TetAspectRatio.tex
  TetCollapseRatio.tex
  TetCondition.tex
  TetDistortion.tex
  TetJacobian.tex
  TetMinimumAngle.tex
  TetRadiusRatio.tex
  TetRelativeSizeSquared.tex
  TetScaledJacobian.tex
  TetShapeAndSize.tex
  TetShape.tex
  TetVolume.tex
  Tri.tex
  TriArea.tex
  TriAspectFrobenius.tex
  TriAspectRatio.tex
  TriCondition.tex
  TriDistortion.tex
  TriEdgeRatio.tex
  TriMaximumAngle.tex
  TriMinimumAngle.tex
  TriRadiusRatio.tex
  TriRelativeSizeSquared.tex
  TriScaledJacobian.tex
  TriShapeAndSize.tex
  TriShape.tex
  OtherEl.tex
  PyrVolume.tex
  WedVolume.tex
  KniVolume.tex
  Verdict-Manual-2007.tex
  )

SET(SVG_FILES
  svg/hex.svg
  svg/quad.svg
  svg/quad-axes.svg
  svg/quad-areas.svg
  svg/quad-vertex-areas.svg
  svg/tet.svg
  svg/tet-height.svg
  svg/tri.svg
  svg/pyramid.svg
  svg/wedge.svg
  svg/knife.svg
)

SET(PNG_FILES
  png/quality-streamingTess.png
  png/tri4qualVR-bq2.png
)

FIND_PACKAGE(LATEX REQUIRED)

set( CMAKE_FIND_APPBUNDLE NEVER )
FIND_PROGRAM(INKSCAPE
  NAMES inkscape
  PATHS
    /usr/local/bin
    /usr/bin
    /Applications/Inkscape.app/Contents/Resources/bin
)

SET(SOURCETEX ${CMAKE_CURRENT_SOURCE_DIR}/${DOCUMENT}.tex)
SET(DESTTEX ${CMAKE_CURRENT_BINARY_DIR}/${DOCUMENT}.tex)

CONFIGURE_FILE("${SOURCETEX}" "${DESTTEX}" @ONLY IMMEDIATE)

SET(depends_files)
FOREACH(file "${LITERATURE}.bib" ${PNG_FILES}  ${SVG_FILES} ${SECTIONS})
  CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/${file}"
    "${CMAKE_CURRENT_BINARY_DIR}/${file}" COPYONLY IMMEDIATE)
  SET(depends_files ${depends_files} "${CMAKE_CURRENT_BINARY_DIR}/${file}")
ENDFOREACH(file)
FOREACH ( SVG_FILE ${SVG_FILES} )
  STRING( REGEX REPLACE "svg" "png" PNG_FILE "${SVG_FILE}" )
  ADD_CUSTOM_COMMAND(
    OUTPUT ${PAPER_BINARY_DIR}/${PNG_FILE}
    COMMAND ${INKSCAPE}
    ARGS -D -d 300 --export-png="${PAPER_BINARY_DIR}/${PNG_FILE}" "${PAPER_SOURCE_DIR}/${SVG_FILE}"
    DEPENDS ${PAPER_SOURCE_DIR}/${SVG_FILE}
    COMMENT "Generating ${PNG_FILE}"
  )
  SET( depends_files ${depends_files} "${PAPER_BINARY_DIR}/${PNG_FILE}" )
ENDFOREACH ( SVG_FILE )

SET(BIBDEP ${PAPER_BINARY_DIR}/${DOCUMENT}.bbl)

ADD_CUSTOM_TARGET(LaTeXDocument ALL echo
  DEPENDS   ${PAPER_BINARY_DIR}/${DOCUMENT}.pdf
  )

IF(WIN32)
  SET(E "#")
  SET(COMMAND_SEP "&")
ELSE(WIN32)
  SET(E "=")
  SET(COMMAND_SEP "\;")
ENDIF(WIN32)

SET(PS2PDF_OPTIONSe
  -sPAPERSIZE${E}letter -dPDFSETTINGS${E}/prepress -dCompatibilityLevel${E}1.3 -dAutoFilterColorImages${E}false -dAutoFilterGrayImages${E}false -dColorImageFilter${E}/FlateEncode -dGrayImageFilter${E}/FlateEncode -dMonoImageFilter${E}/FlateEncode -dDownsampleGrayImages${E}false -dDownsampleColorImages${E}false
  )

ADD_CUSTOM_COMMAND(
  OUTPUT ${PAPER_BINARY_DIR}/${DOCUMENT}.pdf
  COMMAND ${PDFLATEX_COMPILER} -interaction=batchmode ${DESTTEX} ${COMMAND_SEP} ${PDFLATEX_COMPILER} ${DESTTEX}
  DEPENDS ${DESTTEX} ${depends_files} ${PAPER_BINARY_DIR}/${DOCUMENT}.bbl
  COMMENT "Final PDF")

ADD_CUSTOM_COMMAND(
  OUTPUT ${PAPER_BINARY_DIR}/${DOCUMENT}.aux
  COMMAND ${PDFLATEX_COMPILER}
  ARGS ${DESTTEX}
  DEPENDS ${DESTTEX} ${depends_files}
  COMMENT "Generate auxiliary data")

ADD_CUSTOM_COMMAND(
  OUTPUT ${PAPER_BINARY_DIR}/${DOCUMENT}.bbl
  COMMAND ${BIBTEX_COMPILER}
  ARGS ${DOCUMENT}
  DEPENDS ${PAPER_BINARY_DIR}/${DOCUMENT}.aux
  WORKING_DIRECTORY ${PAPER_BINARY_DIR}
  COMMENT "Generate bibliography")

SET(clean_files 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.log 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.aux 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.bbl 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.blg 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.dvi 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.idx 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.lof 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.lot 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.toc 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.ind 
  ${PAPER_BINARY_DIR}/${DOCUMENT}.ilg )

SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${clean_files}")

# .aux:
# .dvi
# .idx: index
# .lof: list of figures
# .log: latex log file
# .lot: list of tables
# .toc: table of contents

# .ind: makeindex output
# .ilg: makeindex log file

# .bib:
# .bbl: bibtex output file
# .blg: bibtex log file

# tetex env var for cls path: TEXINPUTS

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=verdict
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.4.4
pkgrel=1
pkgdesc="Compute quality functions of 2 and 3-dimensional regions (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://github.com/sandialabs/verdict'
msys2_references=(
  'archlinux: verdict'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/sandialabs/verdict/archive/${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('d12d1cd41c6568997df348a72cc2973a662fae1b3634a068ea2201b5f7383186')

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DVERDICT_ENABLE_TESTING=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
